package hibernate;

import negocio.GerenciadorTelefone;
import negocio.produto.GerenciadorLinkFotos;

import org.hibernate.SQLQuery;
import org.hibernate.Session;
import org.hibernate.cfg.AnnotationConfiguration;

import org.hibernate.tool.hbm2ddl.SchemaExport;

import dados.filial.Endereco;
import dados.filial.Filial;
import dados.locacao.Copia;
import dados.locacao.Locacao;
import dados.locacao.ClienteCopiaPK;
import dados.locacao.Periodo;
import dados.locacao.Promocao;
import dados.locacao.Reserva;
import dados.produto.AvaliacaoProduto;
import dados.produto.AvaliacaoProdutoPK;
import dados.produto.ClassificacaoPreco;
import dados.produto.Documentario;
import dados.produto.Filme;
import dados.produto.Jogo;
import dados.produto.LinkFoto;
import dados.produto.Musica;
import dados.produto.Produto;
import dados.produto.Serie;
import dados.usuario.Administrador;
import dados.usuario.Cliente;
import dados.usuario.Dependente;
import dados.usuario.Funcionario;
import dados.usuario.Plano;
import dados.usuario.Telefone;
import dados.usuario.Usuario;

/**
 * Esta classe realiza o mapeamento de todas as classes definidas
 * para entidades relacionais em MySQL.
 * @author Caio Csar
 */
public class GeradorTabelas {
	
	public static void limparBD(){
		HibernateTransaction busca = new HibernateTransaction();
		Session sessao = busca.openSession();
		
		SQLQuery q = sessao.createSQLQuery("TRUNCATE Administrador");
		q.executeUpdate();
		q = sessao.createSQLQuery("TRUNCATE AvaliacaoProduto");
		q.executeUpdate();
		q = sessao.createSQLQuery("TRUNCATE ClassificaoPreco");
		q.executeUpdate();
		q = sessao.createSQLQuery("TRUNCATE Cliente");
		q.executeUpdate();
		q = sessao.createSQLQuery("TRUNCATE Cliente_Telefone");
		q.executeUpdate();
		q = sessao.createSQLQuery("TRUNCATE Copia");
		q.executeUpdate();
		q = sessao.createSQLQuery("TRUNCATE Dependente");
		q.executeUpdate();
		q = sessao.createSQLQuery("TRUNCATE Documentario");
		q.executeUpdate();
		q = sessao.createSQLQuery("TRUNCATE Endereco");
		q.executeUpdate();
		q = sessao.createSQLQuery("TRUNCATE Filial");
		q.executeUpdate();
		q = sessao.createSQLQuery("TRUNCATE Filme");
		q.executeUpdate();
		q = sessao.createSQLQuery("TRUNCATE Funcionario");
		q.executeUpdate();
		q = sessao.createSQLQuery("TRUNCATE Jogo");
		q.executeUpdate();
		q = sessao.createSQLQuery("TRUNCATE LinkFoto");
		q.executeUpdate();
		q = sessao.createSQLQuery("TRUNCATE Locacao");
		q.executeUpdate();
		q = sessao.createSQLQuery("TRUNCATE Musica");
		q.executeUpdate();
		q = sessao.createSQLQuery("TRUNCATE Plano");
		q.executeUpdate();
		q = sessao.createSQLQuery("TRUNCATE Produto");
		q.executeUpdate();
		q = sessao.createSQLQuery("TRUNCATE Produto_Copia");
		q.executeUpdate();
		q = sessao.createSQLQuery("TRUNCATE Produto_LinkFoto");
		q.executeUpdate();
		q = sessao.createSQLQuery("TRUNCATE Promocao");
		q.executeUpdate();
		q = sessao.createSQLQuery("TRUNCATE Reserva");
		q.executeUpdate();
		q = sessao.createSQLQuery("TRUNCATE Serie");
		q.executeUpdate();
		q = sessao.createSQLQuery("TRUNCATE Telefone");
		q.executeUpdate();
		q = sessao.createSQLQuery("TRUNCATE Usuario");
		q.executeUpdate();		
		/*
		SQLQuery q = sessao.createSQLQuery("DELETE FROM Administrador");
		q.executeUpdate();
		q = sessao.createSQLQuery("DELETE FROM AvaliacaoProduto");
		q.executeUpdate();
		q = sessao.createSQLQuery("DELETE FROM ClassificaoPreco");
		q.executeUpdate();
		q = sessao.createSQLQuery("DELETE FROM Cliente");
		q.executeUpdate();
		q = sessao.createSQLQuery("DELETE FROM Cliente_Telefone");
		q.executeUpdate();
		q = sessao.createSQLQuery("DELETE FROM Copia");
		q.executeUpdate();
		q = sessao.createSQLQuery("DELETE FROM Dependente");
		q.executeUpdate();
		q = sessao.createSQLQuery("DELETE FROM Documentario");
		q.executeUpdate();
		q = sessao.createSQLQuery("DELETE FROM Endereco");
		q.executeUpdate();
		q = sessao.createSQLQuery("DELETE FROM Filial");
		q.executeUpdate();
		q = sessao.createSQLQuery("DELETE FROM Filme");
		q.executeUpdate();
		q = sessao.createSQLQuery("DELETE FROM Funcionario");
		q.executeUpdate();
		q = sessao.createSQLQuery("DELETE FROM Jogo");
		q.executeUpdate();
		q = sessao.createSQLQuery("DELETE FROM LinkFoto");
		q.executeUpdate();
		q = sessao.createSQLQuery("DELETE FROM Locacao");
		q.executeUpdate();
		q = sessao.createSQLQuery("DELETE FROM Musica");
		q.executeUpdate();
		q = sessao.createSQLQuery("DELETE FROM Plano");
		q.executeUpdate();
		q = sessao.createSQLQuery("DELETE FROM Produto");
		q.executeUpdate();
		q = sessao.createSQLQuery("DELETE FROM Produto_Copia");
		q.executeUpdate();
		q = sessao.createSQLQuery("DELETE FROM Produto_LinkFoto");
		q.executeUpdate();
		q = sessao.createSQLQuery("DELETE FROM Promocao");
		q.executeUpdate();
		q = sessao.createSQLQuery("DELETE FROM Reserva");
		q.executeUpdate();
		q = sessao.createSQLQuery("DELETE FROM Serie");
		q.executeUpdate();
		q = sessao.createSQLQuery("DELETE FROM Telefone");
		q.executeUpdate();
		q = sessao.createSQLQuery("DELETE FROM Usuario");
		q.executeUpdate();
		*/
		sessao.close();
	}

	public static void main(String[] args) {
		AnnotationConfiguration cfg = new AnnotationConfiguration();
		cfg.addAnnotatedClass(Endereco.class);
		cfg.addAnnotatedClass(Filial.class);
		cfg.addAnnotatedClass(Copia.class);
		cfg.addAnnotatedClass(Locacao.class);
		cfg.addAnnotatedClass(ClienteCopiaPK.class);
		cfg.addAnnotatedClass(Periodo.class);
		cfg.addAnnotatedClass(Promocao.class);
		cfg.addAnnotatedClass(Reserva.class);
		cfg.addAnnotatedClass(AvaliacaoProduto.class);
		cfg.addAnnotatedClass(AvaliacaoProdutoPK.class);
		cfg.addAnnotatedClass(ClassificacaoPreco.class);
		cfg.addAnnotatedClass(Documentario.class);
		cfg.addAnnotatedClass(Filme.class);
		cfg.addAnnotatedClass(Jogo.class);
		cfg.addAnnotatedClass(LinkFoto.class);
		cfg.addAnnotatedClass(Musica.class);
		cfg.addAnnotatedClass(Produto.class);
		cfg.addAnnotatedClass(Serie.class);
		cfg.addAnnotatedClass(Administrador.class);
		cfg.addAnnotatedClass(Cliente.class);
		cfg.addAnnotatedClass(Dependente.class);
		cfg.addAnnotatedClass(Funcionario.class);
		cfg.addAnnotatedClass(Plano.class);
		cfg.addAnnotatedClass(Telefone.class);
		cfg.addAnnotatedClass(Usuario.class);
		cfg.addAnnotatedClass(GerenciadorTelefone.class);
		cfg.addAnnotatedClass(GerenciadorLinkFotos.class);
		new SchemaExport(cfg).create(true, true);
	}
}
