package hibernate;



import negocio.GerenciadorTelefone;
import negocio.produto.GerenciadorLinkFotos;

import org.hibernate.SessionFactory;
import org.hibernate.cfg.AnnotationConfiguration;

import dados.filial.Endereco;
import dados.filial.Filial;
import dados.locacao.Copia;
import dados.locacao.Locacao;
import dados.locacao.ClienteCopiaPK;
import dados.locacao.Periodo;
import dados.locacao.Promocao;
import dados.locacao.Reserva;
import dados.produto.AvaliacaoProduto;
import dados.produto.AvaliacaoProdutoPK;
import dados.produto.ClassificacaoPreco;
import dados.produto.Documentario;
import dados.produto.Filme;
import dados.produto.Jogo;
import dados.produto.LinkFoto;
import dados.produto.Musica;
import dados.produto.Produto;
import dados.produto.Serie;
import dados.usuario.Administrador;
import dados.usuario.Cliente;
import dados.usuario.Dependente;
import dados.usuario.Funcionario;
import dados.usuario.Plano;
import dados.usuario.Telefone;
import dados.usuario.Usuario;

public class HibernateFactory {
	
	private static SessionFactory sessionFactory;

	static {
		try {
			AnnotationConfiguration cfg = new AnnotationConfiguration();
			cfg.addAnnotatedClass(Endereco.class);
			cfg.addAnnotatedClass(Filial.class);
			cfg.addAnnotatedClass(Copia.class);
			cfg.addAnnotatedClass(Locacao.class);
			cfg.addAnnotatedClass(ClienteCopiaPK.class);
			cfg.addAnnotatedClass(Periodo.class);
			cfg.addAnnotatedClass(Promocao.class);
			cfg.addAnnotatedClass(Reserva.class);
			cfg.addAnnotatedClass(AvaliacaoProduto.class);
			cfg.addAnnotatedClass(AvaliacaoProdutoPK.class);
			cfg.addAnnotatedClass(ClassificacaoPreco.class);
			cfg.addAnnotatedClass(Documentario.class);
			cfg.addAnnotatedClass(Filme.class);
			cfg.addAnnotatedClass(Jogo.class);
			cfg.addAnnotatedClass(LinkFoto.class);
			cfg.addAnnotatedClass(Musica.class);
			cfg.addAnnotatedClass(Produto.class);
			cfg.addAnnotatedClass(Serie.class);
			cfg.addAnnotatedClass(Administrador.class);
			cfg.addAnnotatedClass(Cliente.class);
			cfg.addAnnotatedClass(Dependente.class);
			cfg.addAnnotatedClass(Funcionario.class);
			cfg.addAnnotatedClass(Plano.class);
			cfg.addAnnotatedClass(Telefone.class);
			cfg.addAnnotatedClass(Usuario.class);
			cfg.addAnnotatedClass(GerenciadorTelefone.class);
			cfg.addAnnotatedClass(GerenciadorLinkFotos.class);
			
			HibernateFactory.sessionFactory = cfg.buildSessionFactory();
		} catch (Throwable ex) {
			System.err.println("Initial SessionFactory creation failed." + ex);
			throw new ExceptionInInitializerError(ex);
		}
	}
	
	public static SessionFactory getSessionFactory(){
		return HibernateFactory.sessionFactory;
	}
}
