package hibernate;

import org.hibernate.Session;
import org.hibernate.SessionFactory;

public class HibernateTransaction {

	private Session session;

	public Session openSession() {
		if (this.session == null) {
			SessionFactory sf = HibernateFactory.getSessionFactory();
			this.session = sf.openSession();
		}
		return this.session;
	}

	public void closeSession() {
		if (this.session != null) {
			SessionFactory sf = HibernateFactory.getSessionFactory();
			sf.close();
			this.session.close();
			this.session = null;
		}
	}

	public void openSessionBegin() {
		if (this.session == null) {
			SessionFactory sf = HibernateFactory.getSessionFactory();
			this.session = sf.openSession();
			this.session.beginTransaction();
		}
	}

	public void closeSessionCommit() {
		if (this.session != null) {
			this.session.getTransaction().commit();
			this.closeSession();
		}
	}

	public void transactionRollBack() {
		if (this.session != null) {
			this.session.getTransaction().rollback();
			this.closeSession();
		}
	}

	public Session getSession() {
		return this.session;
	}
}
