package insercoes;

import hibernate.GeradorTabelas;
import hibernate.HibernateTransaction;

import java.io.File;
import java.io.FileNotFoundException;
import java.net.MalformedURLException;
import java.rmi.Naming;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;
import java.util.Scanner;

import negocio.exception.ClassificacaoExistenteException;
import negocio.exception.CopiaExistenteException;
import negocio.exception.FilialExistenteException;
import negocio.exception.LinkFotoExistenteException;
import negocio.exception.PlanoExistenteException;
import negocio.exception.PlanoInexistenteException;
import negocio.exception.ProdutoExistenteException;
import negocio.exception.ProdutoInexistenteException;
import negocio.exception.PromocaoExistenteException;
import negocio.exception.SenhaInvalidaException;
import negocio.exception.UsuarioInexistenteException;
import negocio.exception.UsuarioLogadoException;
import negocio.exception.UsuarioNaoLogadoException;
import negocio.exception.UsuarioSemPermissaoException;

import org.hibernate.Session;
import org.junit.Assert;

import servicos.InterfaceGeral;
import servicos.InterfaceWebBD;
import dados.exception.CopiaInvalidaException;
import dados.exception.CpfInvalidoException;
import dados.exception.EmailInvalidoException;
import dados.exception.EnderecoInvalidoException;
import dados.exception.FilialInvalidaException;
import dados.exception.LinkFotoInvalidoException;
import dados.exception.NomeInvalidoException;
import dados.exception.PlanoInvalidoException;
import dados.exception.PromocaoInvalidaException;
import dados.exception.TelefoneInvalidoException;

import dados.exception.PrecoInvalidoException;
import dados.exception.ProdutoInvalidoException;
import dados.filial.Endereco;
import dados.filial.Filial;
import dados.locacao.Copia;
import dados.locacao.Promocao;
import dados.produto.ClassificacaoPreco;
import dados.produto.ClassificacaoPrecoInvalida;
import dados.produto.Documentario;
import dados.produto.Filme;
import dados.produto.LinkFoto;
import dados.produto.Musica;
import dados.produto.Serie;
import dados.produto.TipoLinkFoto;
import dados.usuario.Administrador;
import dados.usuario.Cliente;
import dados.usuario.Funcionario;
import dados.usuario.Plano;
import dados.usuario.Telefone;

public class InserirDadosBD {
	
	private static InterfaceWebBD interfaceWebBD;
	
	private static long sessao;
	private static Filial f[] = new Filial[5];

	public static void init(){
		GeradorTabelas.limparBD();

		try {
			String ipConfig = String.format("rmi://%s:1099/",InterfaceGeral.ip);
			InserirDadosBD.interfaceWebBD = (InterfaceWebBD) Naming.lookup(ipConfig +	"InterfaceWebBD");
		} catch (MalformedURLException e1) {
			Assert.assertTrue(false);
		} catch (RemoteException e1) {
			Assert.assertTrue(false);
		} catch (NotBoundException e1) {
			Assert.assertTrue(false);
		}

		Administrador admin = null;

		try {
			admin = new Administrador(Long.parseLong("05497966497"), "password", "admin", "teste@teste.com");
		} catch (NumberFormatException e) {
		} catch (NomeInvalidoException e) {
		} catch (SenhaInvalidaException e) {
		} catch (CpfInvalidoException e) {
		} catch (EmailInvalidoException e) {
		}

		HibernateTransaction busca = new HibernateTransaction();
		busca.openSessionBegin();
		Session sessao = busca.getSession();

		sessao.save(admin);

		busca.closeSessionCommit();
	}
	
	private static void logar(){
		try {
			InserirDadosBD.sessao = InserirDadosBD.interfaceWebBD.logarUsuario(Long.parseLong("05497966497"), "password");
		} catch (NumberFormatException e) {
			e.printStackTrace();
		} catch (RemoteException e) {
			e.printStackTrace();
		} catch (UsuarioLogadoException e) {
			e.printStackTrace();
		} catch (UsuarioInexistenteException e) {
			e.printStackTrace();
		} catch (SenhaInvalidaException e) {
			e.printStackTrace();
		}
	}
	
	private static void deslogar(){
		try {
			InserirDadosBD.interfaceWebBD.deslogar(sessao);
		} catch (RemoteException e) {
			e.printStackTrace();
		} catch (UsuarioNaoLogadoException e) {
			e.printStackTrace();
		}
	}
	
	private static void inserirUsuarios() {
		Funcionario[] func = new Funcionario[5];
		Cliente c = null;

		try {
			c = new Cliente(Long.parseLong("08902507408"), "senhagrande", "Caio Csar Sabino Silva", "ccss2@cin.ufpe.br", interfaceWebBD.buscarPlano("Plano Especial"), new Endereco("Av Santos Dumont", "PE", "Recife", "Rosarinho", null, 881, 52041060));
			func[0] = new Funcionario(Long.parseLong("05631071460"), "password", "Jos", "teste@teste1.com", InserirDadosBD.f[0]);
			func[1] = new Funcionario(Long.parseLong("09317891411"), "password", "Antonio", "teste@teste2.com",InserirDadosBD.f[1]);
			func[2] = new Funcionario(Long.parseLong("05246798437"), "password", "Maria", "teste@teste3.com",InserirDadosBD.f[2]);
			func[3] = new Funcionario(Long.parseLong("07692172498"), "password", "Luciano", "teste@teste4.com",InserirDadosBD.f[3]);
			func[4] = new Funcionario(Long.parseLong("08193578473"), "password", "Lucas", "teste@teste5.com",InserirDadosBD.f[4]);
		} catch (NumberFormatException e) {
			e.printStackTrace();
		} catch (NomeInvalidoException e) {
			e.printStackTrace();
		} catch (SenhaInvalidaException e) {
			e.printStackTrace();
		} catch (CpfInvalidoException e) {
			e.printStackTrace();
		} catch (EmailInvalidoException e) {
			e.printStackTrace();
		} catch (FilialInvalidaException e) {
			e.printStackTrace();
		} catch (RemoteException e) {
			e.printStackTrace();
		} catch (EnderecoInvalidoException e) {
			e.printStackTrace();
		} catch (PlanoInvalidoException e) {
			e.printStackTrace();
		} catch (PlanoInexistenteException e) {
			e.printStackTrace();
		}

		HibernateTransaction busca = new HibernateTransaction();
		busca.openSessionBegin();
		Session sessao = busca.getSession();

		for(int i = 0; i < 5; i++)
			sessao.save(func[i]);
		sessao.save(c);

		busca.closeSessionCommit();
	}

	private static void inserirProdutos() {
		
		ClassificacaoPreco catalogo = null;
		ClassificacaoPreco lancamento =	null;
		try {
			catalogo =  new ClassificacaoPreco("CATLOGO", 4);
			lancamento = new ClassificacaoPreco("LANAMENTO", 5);
			interfaceWebBD.inserirClassificacao(sessao, lancamento);
			interfaceWebBD.inserirClassificacao(sessao, catalogo);
			
		} catch (PrecoInvalidoException e1) {
			e1.printStackTrace();
		} catch (ClassificacaoPrecoInvalida e1) {
			e1.printStackTrace();
		} catch (RemoteException e) {
			e.printStackTrace();
		} catch (UsuarioNaoLogadoException e) {
			e.printStackTrace();
		} catch (ClassificacaoExistenteException e) {
			e.printStackTrace();
		} catch (UsuarioSemPermissaoException e) {
			e.printStackTrace();
		}
		
		File file  = new File("ArquivosInsercao/filmes.txt");
		Scanner s = null;
		int qtdProdutos = 0, numeroSeq = 0;
		
		try {
			s = new Scanner(file);
			
			while(s.hasNext()){
				Filme f = new Filme(s.nextLine(), s.nextLine(), s.nextLine(), s.nextLine(), s.nextLine(), s.nextLine(), s.nextLine(), s.nextLine(), catalogo, Integer.parseInt(s.nextLine()), Integer.parseInt(s.nextLine())); 
				
				if(f.getAnoLancamento()==2009){
					f.setClassificacaoPreco(lancamento);
				}
				
				interfaceWebBD.cadastrarProduto(sessao, f);
				
				qtdProdutos++;
				
				interfaceWebBD.inserirLinkFoto(f.getNome(), new LinkFoto(TipoLinkFoto.POSTER, s.nextLine()));
				interfaceWebBD.inserirLinkFoto(f.getNome(), new LinkFoto(TipoLinkFoto.NORMAL, s.nextLine()));
				interfaceWebBD.inserirLinkFoto(f.getNome(), new LinkFoto(TipoLinkFoto.NORMAL, s.nextLine()));
				interfaceWebBD.inserirLinkFoto(f.getNome(), new LinkFoto(TipoLinkFoto.NORMAL, s.nextLine()));
				
				for(int w = 0; w < InserirDadosBD.f.length; w++){
					Copia c = new Copia(numeroSeq++, InserirDadosBD.f[w], f);
					interfaceWebBD.cadastrarCopia(sessao, c);
				}
				
				s.nextLine();
			}
			
			s.close();
			
			file = new File("ArquivosInsercao/documentarios.txt");
			s = new Scanner(file);
			
			while(s.hasNext()){
				Documentario doc = new Documentario(s.nextLine(), s.nextLine(), s.nextLine(), s.nextLine(), s.nextLine(), s.nextLine(), s.nextLine(), catalogo, Integer.parseInt(s.nextLine()));
				
				qtdProdutos++;
				if(doc.getAnoLancamento()==2009){
					doc.setClassificacaoPreco(lancamento);
				}
				
				interfaceWebBD.cadastrarProduto(sessao, doc);
				interfaceWebBD.inserirLinkFoto(doc.getNome(), new LinkFoto(TipoLinkFoto.POSTER, s.nextLine()));
				interfaceWebBD.inserirLinkFoto(doc.getNome(), new LinkFoto(TipoLinkFoto.NORMAL, s.nextLine()));
				interfaceWebBD.inserirLinkFoto(doc.getNome(), new LinkFoto(TipoLinkFoto.NORMAL, s.nextLine()));
				interfaceWebBD.inserirLinkFoto(doc.getNome(), new LinkFoto(TipoLinkFoto.NORMAL, s.nextLine()));

				for(int w = 0; w < InserirDadosBD.f.length; w++){
					Copia c = new Copia(numeroSeq++, InserirDadosBD.f[w], doc);
					interfaceWebBD.cadastrarCopia(sessao, c);
				}
				
				s.nextLine();
			
			}
			s.close();
			
			file = new File("ArquivosInsercao/dvds_musicais.txt");
			s = new Scanner(file);
			
			while(s.hasNext()){
				Musica mus = new Musica(s.nextLine(), s.nextLine(), s.nextLine(), s.nextLine(), s.nextLine(), s.nextLine(), s.nextLine(), catalogo, Integer.parseInt(s.nextLine()));
				
				if(mus.getAnoLancamento()==2009){
					mus.setClassificacaoPreco(lancamento);
				}
				
				interfaceWebBD.cadastrarProduto(sessao, mus);
				
				qtdProdutos++;
				
				interfaceWebBD.inserirLinkFoto(mus.getNome(), new LinkFoto(TipoLinkFoto.POSTER, s.nextLine()));
				interfaceWebBD.inserirLinkFoto(mus.getNome(), new LinkFoto(TipoLinkFoto.NORMAL, s.nextLine()));
				interfaceWebBD.inserirLinkFoto(mus.getNome(), new LinkFoto(TipoLinkFoto.NORMAL, s.nextLine()));
				interfaceWebBD.inserirLinkFoto(mus.getNome(), new LinkFoto(TipoLinkFoto.NORMAL, s.nextLine()));
				
				for(int w = 0; w < InserirDadosBD.f.length; w++){
					Copia c = new Copia(numeroSeq++, InserirDadosBD.f[w], mus);
					interfaceWebBD.cadastrarCopia(sessao, c);
				}
				
				s.nextLine();
			
			}
			s.close();
			
			file = new File("ArquivosInsercao/series.txt");
			s = new Scanner(file);
			
			while(s.hasNext()){
				Serie serie = new Serie(s.nextLine(), s.nextLine(), s.nextLine(), s.nextLine(), s.nextLine(), s.nextLine(), catalogo, Integer.parseInt(s.nextLine()), Integer.parseInt(s.nextLine()), Integer.parseInt(s.nextLine()), Integer.parseInt(s.nextLine()));
				

				if(serie.getAnoLancamento()==2009){
					serie.setClassificacaoPreco(lancamento);
				}
				
				interfaceWebBD.cadastrarProduto(sessao, serie);
				
				qtdProdutos++;
					
				interfaceWebBD.inserirLinkFoto(serie.getNome(), new LinkFoto(TipoLinkFoto.POSTER, s.nextLine()));
				interfaceWebBD.inserirLinkFoto(serie.getNome(), new LinkFoto(TipoLinkFoto.NORMAL, s.nextLine()));
				interfaceWebBD.inserirLinkFoto(serie.getNome(), new LinkFoto(TipoLinkFoto.NORMAL, s.nextLine()));
				interfaceWebBD.inserirLinkFoto(serie.getNome(), new LinkFoto(TipoLinkFoto.NORMAL, s.nextLine()));

				for(int w = 0; w < InserirDadosBD.f.length; w++){
					Copia c = new Copia(numeroSeq++, InserirDadosBD.f[w], serie);
					interfaceWebBD.cadastrarCopia(sessao, c);
				}
				
				s.nextLine();
			}
			s.close();
			System.out.println("Nmero de Produtos Cadastrados: "+qtdProdutos);
			
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (ProdutoInvalidoException e) {
			e.printStackTrace();
		} catch (LinkFotoExistenteException e) {
			e.printStackTrace();
		} catch (LinkFotoInvalidoException e) {
			e.printStackTrace();
		} catch (RemoteException e) {
			e.printStackTrace();
		} catch (UsuarioNaoLogadoException e) {
			e.printStackTrace();
		} catch (UsuarioSemPermissaoException e) {
			e.printStackTrace();
		} catch (ProdutoExistenteException e) {
			e.printStackTrace();
		} catch (ProdutoInexistenteException e) {
			e.printStackTrace();
		} catch (CopiaInvalidaException e) {
			e.printStackTrace();
		} catch (CopiaExistenteException e) {
			e.printStackTrace();
		}
	}
	
	private static void inserirPlanos() {
		try {
			Plano p[] = new Plano[4];
			p[0] = new Plano(29.90, "Plano Especial", "Pode alugar at 10 filmes por ms de graa.", 10, new LinkFoto(TipoLinkFoto.POSTER, "http://i50.tinypic.com/2z9e7x4.png"));
			p[1] = new Plano(0.0, "Plano Bsico", "Plano bsico gratuito que no oferece locaes gratuitas", 0, new LinkFoto(TipoLinkFoto.POSTER, "http://i50.tinypic.com/2z9e7x4.png"));
			p[2] = new Plano(49.90, "Plano Super", "Pode alugar at 30 filmes por ms de graa.", 30, new LinkFoto(TipoLinkFoto.POSTER, "http://i50.tinypic.com/2z9e7x4.png"));
			p[3] = new Plano(59.90, "Plano Famlia", "Pode alugar at 60 filmes por ms de graa.", 60, new LinkFoto(TipoLinkFoto.POSTER, "http://i50.tinypic.com/2z9e7x4.png"));
			
			for(int i = 0; i < 4; i++){
				InserirDadosBD.interfaceWebBD.cadastrarPlano(InserirDadosBD.sessao, p[i]);
			}
		} catch (PlanoInvalidoException e) {
			e.printStackTrace();
		} catch (LinkFotoInvalidoException e) {
			e.printStackTrace();
		} catch (RemoteException e) {
			e.printStackTrace();
		} catch (UsuarioSemPermissaoException e) {
			e.printStackTrace();
		} catch (UsuarioNaoLogadoException e) {
			e.printStackTrace();
		} catch (PlanoExistenteException e) {
			e.printStackTrace();
		}
	}

	private static void inserirPromocoes() {
		try {
			Promocao p[] = new Promocao[3];
			p[0] = new Promocao("Final de semana prolongado", "Leve 5 filmes de uma vez na sexta e devolva apenas na tera feira pelo mesmo preo.", new LinkFoto(TipoLinkFoto.POSTER, "http://i46.tinypic.com/11w3ck1.png"));
			p[1] = new Promocao("Quarta-feira premiada", "Alugue filmes na quarta feira pela metade do preo..", new LinkFoto(TipoLinkFoto.POSTER, "http://i46.tinypic.com/11w3ck1.png"));
			p[2] = new Promocao("Cinema em casa", "Pea a partir de 3 filmes  domiclio e receba as cpias em casa sem pagar o frete!.", new LinkFoto(TipoLinkFoto.POSTER, "http://i46.tinypic.com/11w3ck1.png"));
			
			for(int i = 0; i < 3; i++){
				InserirDadosBD.interfaceWebBD.cadastrarPromocao(InserirDadosBD.sessao, p[i]);
			}
		} catch (LinkFotoInvalidoException e) {
			e.printStackTrace();
		} catch (RemoteException e) {
			e.printStackTrace();
		} catch (UsuarioSemPermissaoException e) {
			e.printStackTrace();
		} catch (UsuarioNaoLogadoException e) {
			e.printStackTrace();
		} catch (PromocaoInvalidaException e) {
			e.printStackTrace();
		} catch (PromocaoExistenteException e) {
			e.printStackTrace();
		}
	}

	private static void inserirFiliais() {
		try {
			f = new Filial[5];
			f[0] = new Filial("Filial Rosarinho", new Telefone(81, 88486732), new Endereco("Av Santos Dumont", "PE", "Recife", "Rosarinho", "loja", 881, 52041060));
			f[1] = new Filial("Filial Setbal", new Telefone(81, 33416777), new Endereco("Rua Izabel Magalhes", "PE", "Recife", "Boa Viagem", "loja", 313, 51030330));
			f[2] = new Filial("Filial Camaragibe", new Telefone(81, 34560660), new Endereco("Rua Maria Adlia Collier", "PE", "Camaragibe", "Centro", "loja", 81, 54759430));
			f[3] = new Filial("Filial Areias", new Telefone(81, 88486732), new Endereco("Rua Dona Ana Aurora", "PE", "Recife", "Areias", "loja", 837, 50870540));
			f[4] = new Filial("Filial Vrzea", new Telefone(81, 88486732), new Endereco("Rua Cassilndia", "PE", "Recife", "Vrzea", "loja", 110, 50740370));
			
			for(int i = 0; i < 5; i++){
				InserirDadosBD.interfaceWebBD.cadastrarFilial(InserirDadosBD.sessao, f[i]);
			}
		} catch (RemoteException e) {
			e.printStackTrace();
		} catch (UsuarioSemPermissaoException e) {
			e.printStackTrace();
		} catch (UsuarioNaoLogadoException e) {
			e.printStackTrace();
		} catch (FilialExistenteException e) {
			e.printStackTrace();
		} catch (FilialInvalidaException e) {
			e.printStackTrace();
		} catch (TelefoneInvalidoException e) {
			e.printStackTrace();
		} catch (EnderecoInvalidoException e) {
			e.printStackTrace();
		}
	}
	
	public static void main(String[] args) {
		InserirDadosBD.init();
		System.out.println("init completo");
		InserirDadosBD.logar();	
		System.out.println("logado");
		InserirDadosBD.inserirFiliais();
		System.out.println("filiais completas");
		InserirDadosBD.inserirPlanos();
		System.out.println("planos completos");
		InserirDadosBD.inserirUsuarios();
		System.out.println("usuarios completos");
		InserirDadosBD.inserirPromocoes();
		System.out.println("promocoes completas");
		InserirDadosBD.inserirProdutos();
		System.out.println("produtos completos");
		InserirDadosBD.deslogar();
		System.out.println("deslogado");
	}

}
