package servicos;

import java.rmi.RemoteException;

import dados.usuario.Funcionario;
import dados.usuario.Usuario;

import negocio.exception.FilialInexistenteException;
import negocio.exception.FilialLogadaException;
import negocio.exception.FilialNaoLogadaException;
import negocio.exception.UsuarioNaoLogadoException;
import negocio.exception.UsuarioSemPermissaoException;

public class InterfaceFilialBDImp extends InterfaceGeralImp implements InterfaceFilialBD{
	
	private static final long serialVersionUID = 1L;
	
	public InterfaceFilialBDImp() throws RemoteException {
		super();
	}
	
	@Override
	public synchronized void deslogarFilial(long sessao, String nome) throws RemoteException, FilialNaoLogadaException, FilialInexistenteException, UsuarioSemPermissaoException, UsuarioNaoLogadoException {
		Usuario user = this.gerenciadorUsuario.getUsuarioLogado(sessao);
		if(user instanceof Funcionario){
			if(((Funcionario) user).getFilial().getNome().equals(nome)){
				this.gerenciadorFilial.deslogarFilial(nome);
			} else {
				throw new UsuarioSemPermissaoException(user);
			}
		} else {
			throw new UsuarioSemPermissaoException(user);
		}
	}

	@Override
	public synchronized void logarFilial(long sessao, String nome) throws RemoteException, FilialLogadaException, FilialInexistenteException, UsuarioNaoLogadoException, UsuarioSemPermissaoException {
		Usuario user = this.gerenciadorUsuario.getUsuarioLogado(sessao);
		if(user instanceof Funcionario){
			if(((Funcionario) user).getFilial().getNome().equals(nome)){
				this.gerenciadorFilial.logarFilial(this.gerenciadorFilial.buscarFilial(nome));
			} else {
				throw new UsuarioSemPermissaoException(user);
			}		
		} else {
			throw new UsuarioSemPermissaoException(user);
		}
	}
	
}
