package servicos;

import java.rmi.RemoteException;

import dados.filial.Endereco;
import dados.locacao.Locacao;
import dados.locacao.Reserva;

public class ThreadNotificar extends Thread {

	private InterfaceFilial servico;
	private Object[] parametros;
	private String funcao;

	public ThreadNotificar(InterfaceFilial servico, Object[] parametros, String funcao){
		this.funcao = funcao;
		this.parametros = parametros;
		this.servico = servico;
	}

	@Override
	public void run() {
		try {
			if(this.funcao.equalsIgnoreCase("notificarLocacaoDomicilio")){
				servico.notificarLocacaoDomicilio((Locacao) this.parametros[0], (Endereco)this.parametros[1]);
			} else if(this.funcao.equalsIgnoreCase("notificarReserva")){
				servico.notificarReserva((Reserva) this.parametros[0]);
			} else if(this.funcao.equalsIgnoreCase("notificarRemocaoReserva")){
				servico.notificarRemocaoReserva((Reserva) this.parametros[0]);
			}
		} catch (RemoteException e) {
		}
	}

}
