package servicos;

import java.util.TimerTask;

import negocio.exception.ReservaInexistenteException;
import dados.locacao.Reserva;

public class TimerReserva extends TimerTask {
	
	private Reserva reserva;
	private InterfaceGeralImp servico;

	public TimerReserva(Reserva reserva, InterfaceGeralImp servico) {
		this.reserva = reserva;
		this.servico = servico;
	}

	@Override
	public void run() {
		System.out.println("Expirou a reserva do cliente " + reserva.getCliente().getNome() + "  copia " + reserva.getCopia().getCodigoCopia() + " do produto " + reserva.getCopia().getProduto().getNome());
		try {
			this.servico.removerReserva(reserva.getCliente(), reserva.getCopia());
		} catch (ReservaInexistenteException e) {
			e.printStackTrace();
		}
	}
	
	

}
