package util;

import java.util.ArrayList;
import java.util.Comparator;

import dados.produto.Produto;

public class ComparadorProdutoNome implements Comparator<Produto> {
	
	private ArrayList<String> padrao;
	
	public ComparadorProdutoNome(ArrayList<String> padrao){
		if(padrao != null){
			this.padrao = padrao;
		} else {
			throw new IllegalArgumentException();
		}
	}
	
	@Override
	public int compare(Produto o1, Produto o2) {
		int m1 = 0;
		int m2 = 0;
		
		for(int i = this.padrao.size() - 1; i >= 0; i--){
			if(o1.getNome().toLowerCase().contains(padrao.get(i))){
				m1 = m1+1;
			}
			
			if(o2.getNome().toLowerCase().contains(padrao.get(i))){
				m2 = m2+1;
			}
		}
		
		int retorno = 1;
		
		if(m1 > m2){
			retorno = -1;
		} else if(o1.equals(o2)){
			retorno = 0;
		}
		
		return retorno;
	}

}
